package com.ibm.websphere.fabric.insurance.pc.contextextractor;

import java.util.logging.Logger;

import com.ibm.websphere.fabric.da.PendingRequest;
import com.ibm.websphere.fabric.da.context.Context;
import com.ibm.websphere.fabric.da.plugin.ContextExtractor;
import com.ibm.websphere.fabric.da.plugin.UnexpectedContentException;
import com.ibm.websphere.fabric.da.types.TypedValue;
import com.ibm.websphere.sca.ServiceManager;


public class DefaultContextExtractorImpl implements ContextExtractor {
	
	 private final Logger logger = Logger.getLogger("RoleAssertionContextExtractorImpl");
	
	private static final String FABRIC_GOVERNANCE = "fc://fabric/governance/fabricproject-inst#3c765894-632c-4866-810a-ac74e16b16b0";

	private static final String FABRIC_GOVERNANCE_VALUE = "http://www.webifysolutions.com/2005/10/catalog/governance#FabricProject";

	 /**
	 * Default constructor.
	 */
	public DefaultContextExtractorImpl() {
		super();
	}

	/**
	 * Return a reference to the component service instance for this implementation
	 * class.  This method should be used when passing this service to a partner reference
	 * or if you want to invoke this component service asynchronously.    
	 *
	 * @generated (com.ibm.wbit.java)
	 */
	@SuppressWarnings("unused")
	private ContextExtractor getMyService() {
		return (ContextExtractor) ServiceManager.INSTANCE.locateService("self");
	}

	/* (non-Javadoc)
	 * @see com.ibm.websphere.fabric.da.plugin.ContextExtractor#extractContext(PendingRequest arg0) 
	 */
	public Context extractContext(PendingRequest pendingRequest)
			throws UnexpectedContentException {

        Context context = pendingRequest.getContext();
        logger.info("context.:" + context.getSelectionPropertyNames());

		TypedValue governanceFabricProjectValue = new TypedValue(FABRIC_GOVERNANCE);
		context.setSelectionProperty(FABRIC_GOVERNANCE_VALUE,governanceFabricProjectValue);

		return context;
	}

}