/***********************************************
 * Licensed Materials - Property of IBM
 * 
 * 5724-R31, 5655-S30
 *
 * (C) Copyright IBM Corp. 2002, 2007 All Rights Reserved.
 * (C) Copyright Webify Solutions, Inc. 2002, 2006 All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ***********************************************
 */
package com.ibm.websphere.fabric.insurance.pc.contextinjector;

//CHECKSTYLE:OFF

import java.util.List;

import com.ibm.websphere.fabric.da.context.InContextServiceInvoker;
import com.ibm.websphere.fabric.insurance.pc.process.ClaimSummaryAcordGtwyBP;
import com.ibm.websphere.sca.Service;
import com.ibm.websphere.sca.ServiceManager;
import com.ibm.websphere.sca.Ticket;
import commonj.sdo.DataObject;

/**
 * Takes the context properties from the request and uses the ContextPropagator to
 * inject the context properties for the service.
 * 
 * @author govindm
 */
public class ContextInjectorClientImpl {

    /**
     * Default constructor.
     */
    public ContextInjectorClientImpl() {

        super();
    }

    /**
     * Return a reference to the component service instance for this
     * implementation class. This method should be used when passing this
     * service to a partner reference or if you want to invoke this component
     * service asynchronously.
     * 
     * @generated (com.ibm.wbit.java)
     */   
//    private Object getMyService() {
//        return (Object) ServiceManager.INSTANCE.locateService("self");
//    }

    /**
     * This method is used to locate the service for the reference named
     * "ClaimSummaryAcordGtwyBPPartner". This will return an instance of
     * {@link ClaimSummaryAcordGtwyBP}. 
     * 
     * @generated (com.ibm.wbit.java)
     * 
     * @return ClaimSummaryAcordGtwyBP
     */
   //CHECKSTYLE:OFF
    public ClaimSummaryAcordGtwyBP locateService_ClaimSummaryAcordGtwyBPPartner() { 
    //CHECKSTYLE:ON

        return (ClaimSummaryAcordGtwyBP) ServiceManager.INSTANCE
                .locateService("ClaimSummaryAcordGtwyBPPartner");
    }
    
    /**
     * Injects the context properties for the service.
     * 
     * @see com.ibm.websphere.fabric.insurance.pc.process.ClaimSummaryAcordGtwyBP#operation1(commonj.sdo.DataObject)
     */
    public DataObject getClaimSummary(DataObject request, DataObject contextHeader) {

        ClaimSummaryContext contextWrapper = new ClaimSummaryContext(request, contextHeader);
        return (DataObject) contextWrapper.invokeInContext();  
    }
   
    /**
     * Method generated to support the async implementation using callback for the operation.
     */
    //CHECKSTYLE:OFF
    public void onGetClaimSummaryResponse(Ticket __ticket, DataObject returnValue, Exception exception) {
        // not implemented
    }
    //CHECKSTYLE:ON
    
    /**
     * Implementation for InContextServiceInvoker.
     * 
     * @author govindm
     */
    private class ClaimSummaryContext extends InContextServiceInvoker {

        public ClaimSummaryContext(DataObject request, DataObject contextHeader) {
            super(request, contextHeader);
            List list = contextHeader.getList("property");

            for (int i = 0; i < list.size(); ++i) {
                DataObject pair = (DataObject) list.get(i);
                String key = pair.getString("name");
                String val = pair.getString(0);
                setSelectionProperty(key, val);
            }
        }

        public Object invoke() {
            Service svc = (Service) locateService_ClaimSummaryAcordGtwyBPPartner(); 
            return svc.invoke("getClaimSummary", getBody());
        }        
    }
}
